/* FILE NAME: client.c */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rfile.h"
#define MAX 200         /* maximum line length for a file */

main(argc, argv)
int argc;
char *argv[];
{
   FILE         *local_fh;             /* file handle for client file input */
   char         host[100];        /* name or network address of remote host */
   char         remote_name[100];                    /* name of remote file */
   rpc_binding_handle_t binding_h;                        /* binding handle */
   filehandle   remote_fh;                                /* context handle */
   buffer       *buf_ptr;                   /* buffer pointer for data sent */
   int          size;                                /* size of data buffer */

   get_args(argc, argv, &local_fh, host, (char *)remote_name);
#ifndef LOCAL
   if(do_string_binding(host, &binding_h) < 0) {
      fprintf(stderr, "Cannot get binding\n");
      exit(1);
   }
#endif
   remote_fh = remote_open(binding_h, remote_name, (char *)"w");
   if(remote_fh == NULL) {
      fprintf(stderr, "Cannot open remote file\n");
      exit(1);
   }

   /* The buffer data type is a conformant array of bytes; */
   /* memory must be allocated for a conformant array.     */
   buf_ptr = (buffer *)malloc((MAX+1) * sizeof(buffer));

   while( fgets((char *)buf_ptr, MAX, local_fh) != NULL) {
      size = (int)strlen((char *)buf_ptr); /* data sent will not include \0 */
      if( remote_send(remote_fh, (*buf_ptr), size) < 1) {
         fprintf(stderr, "Cannot write to remote file\n");
         exit(1);
      }
   }
   remote_close(&remote_fh);
}
