/* FILE NAME: manager.c */
#include <stdio.h>
#include <string.h>
#include <io.h>
#include <errno.h>
#include "rfile.h"

filehandle remote_open(binding_h, name, mode)
rpc_binding_handle_t binding_h;
char                 name[];
char                 mode[];
{
   FILE *FILEh;

   if(strlen((char *)name) == 0)                      /* no file name given */
      if(strcmp((char *)mode, "r") == 0)
         FILEh = NULL;                      /* cannot read nonexistent file */
      else FILEh = stdout;                             /* use server stdout */

   else if(_access((char *)name, 0) == 0)                     /* file exists */
      if(strcmp((char *)mode, "w") == 0)
         FILEh = NULL;                    /* do not overwrite existing file */
      else FILEh = fopen((char *)name, (char *)mode);   /* open read/append */

   else                                              /* file does not exist */
      if(strcmp((char *)mode, "r") == 0)
         FILEh = NULL;                      /* cannot read nonexistent file */
      else FILEh = fopen((char *)name, (char *)mode);  /* open write/append */

   return( (filehandle)FILEh );       /* cast FILE handle to context handle */
}


long int remote_send(fh, buf, max)
filehandle fh;
buffer buf;
long int max;
{
   /* write data to the file (context), which is cast as a FILE pointer */
   return( fwrite(buf, max, 1, fh) );
}


void remote_close(fh)
filehandle *fh;  /* the client stub needs the changed value upon return */
{
   if( (FILE *)(*fh) != stdout )
      fclose( (FILE *)(*fh) );
   (*fh) = NULL;        /* assign NULL to the context handle to free it */
   return;
}
